#ifndef INC_CHANNELCONTROLLER_H_
#define INC_CHANNELCONTROLLER_H_

#include "stm32l5xx_hal.h"

#define NUMBER_OF_CHANNELS			2

void ChannelController_ThreadEntry(int channelNo);
int ChannelController_IsRunning(int channelNo);
int ChannelController_IsError(int channelNo);
void ChannelController_Start(int channelNo);
void ChannelController_Stop(int channelNo);
float ChannelController_GetConfiguredVoltage(int channelNo);
float ChannelController_GetActualCurrent(int channelNo);
float ChannelController_GetActualVoltage(int channelNo);
void ChannelController_SetDacToValue(int channelNo, uint16_t value);
void ChannelController_SetDacToZero(int channelNo);
void ChannelController_UpdateDacVoltage(int channelNo);
void ChannelController_SetVoltage(int channelNo, float voltage);
void ChannelController_CalibrateChannel(int channelNo);

typedef struct __attribute__((packed, aligned(4096))) {
	float realVoltage[4096];
	uint8_t isValid[4096];
} CalibrationRecord;

#endif
