#ifndef SEVEN_SEGMENT_H__
#define SEVEN_SEGMENT_H__

#include <stdint.h>

// 4 * (RED + GREEN) + YELLOW
#define DISPLAY_DIGITS 10

#define DISPA_SEG_A 0x0001
#define DISPA_SEG_B 0x0002
#define DISPA_SEG_C 0x0004
#define DISPA_SEG_D 0x0008
#define DISPA_SEG_E 0x0010
#define DISPA_SEG_F 0x0020
#define DISPA_SEG_G 0x0040
#define DISPA_SEG_DOT 0x0080

#define DISPB_SEG_A 0x0001
#define DISPB_SEG_B 0x0002
#define DISPB_SEG_C 0x0010
#define DISPB_SEG_D 0x0200
#define DISPB_SEG_E 0x1000
#define DISPB_SEG_F 0x0800
#define DISPB_SEG_G 0x0080
#define DISPB_SEG_H 0x0004
#define DISPB_SEG_N 0x0008
#define DISPB_SEG_P 0x0040
#define DISPB_SEG_T 0x0100
#define DISPB_SEG_U 0x0020

#define DISPA_DIGIT_0_GREEN 0
#define DISPA_DIGIT_1_GREEN 1
#define DISPA_DIGIT_2_GREEN 2
#define DISPA_DIGIT_3_GREEN 3
#define DISPA_DIGIT_0_RED 4
#define DISPA_DIGIT_1_RED 5
#define DISPA_DIGIT_2_RED 6
#define DISPA_DIGIT_3_RED 7
#define DISPB_CYC1 8
#define DISPB_CYC2 9

void SevenSegment_Init();
void SevenSegment_Clear();
void SevenSegment_ClearA();
void SevenSegment_ClearA_Green();
void SevenSegment_ClearA_Red();
void SevenSegment_ClearB();
void SevenSegment_RefreshDisplay();
void SevenSegment_SetDigit(int digitIndex, uint16_t data);
void SevenSegment_PrintFloat(int digit0Index, float num);

#endif
