#include "MAX5715.h"
#include "stm32l5xx_hal.h"
#include <stdint.h>

extern SPI_HandleTypeDef hspi1;

void MAX5715_Init() {
	HAL_GPIO_WritePin(GPIOA, GPIO_PIN_4, GPIO_PIN_SET);
	uint8_t dummy = 0x42;
	HAL_SPI_Transmit(&hspi1, &dummy, 1, 10);
}

static void MAX5715_Transmit(uint32_t message) {
	uint8_t buffer[3];
	buffer[0] = (message & 0xFF0000) >> 16;
	buffer[1] = (message & 0xFF00) >> 8;
	buffer[2] = (message & 0xFF);

	HAL_GPIO_WritePin(GPIOA, GPIO_PIN_4, GPIO_PIN_RESET);
	if (HAL_SPI_Transmit(&hspi1, buffer, sizeof(buffer), 10)) {
		__BKPT(0);
	}
	HAL_GPIO_WritePin(GPIOA, GPIO_PIN_4, GPIO_PIN_SET);
}

void MAX5715_SetReference(int referencePowerAllways, MAX5715_Reference mode) {
	MAX5715_Transmit(0x700000 | ((!!referencePowerAllways) << 18) | ((mode & 3) << 16));
}

void MAX5715_SetDAC(MAX5715_Channel channels, uint16_t value) {
	MAX5715_Transmit(0x200000 | ((channels & 0xF) << 16) | ((value & 0xFFF) << 4));
}
