/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "cmsis_os.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "SevenSegment.h"
#include "StatusLed.h"
#include "UiController.h"
#include "UART.h"
#include "ChannelController.h"
#include "MAX40080Driver.h"
#include "ButtonDriver.h"
#include "AdcDriver.h"
#include "MAX5715.h"
#include "INA219Driver.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
typedef StaticTask_t osStaticThreadDef_t;
typedef StaticSemaphore_t osStaticMutexDef_t;
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
 ADC_HandleTypeDef hadc1;

I2C_HandleTypeDef hi2c1;
I2C_HandleTypeDef hi2c4;

UART_HandleTypeDef hlpuart1;

SPI_HandleTypeDef hspi1;

TIM_HandleTypeDef htim7;

PCD_HandleTypeDef hpcd_USB_FS;

/* Definitions for defaultTask */
osThreadId_t defaultTaskHandle;
const osThreadAttr_t defaultTask_attributes = {
  .name = "defaultTask",
  .priority = (osPriority_t) osPriorityNormal,
  .stack_size = 128 * 4
};
/* Definitions for max40080_task */
osThreadId_t max40080_taskHandle;
uint32_t max40080_taskBuffer[ 256 ];
osStaticThreadDef_t max40080_taskControlBlock;
const osThreadAttr_t max40080_task_attributes = {
  .name = "max40080_task",
  .stack_mem = &max40080_taskBuffer[0],
  .stack_size = sizeof(max40080_taskBuffer),
  .cb_mem = &max40080_taskControlBlock,
  .cb_size = sizeof(max40080_taskControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for btn1_controller */
osThreadId_t btn1_controllerHandle;
uint32_t btn1_controllerBuffer[ 128 ];
osStaticThreadDef_t btn1_controllerControlBlock;
const osThreadAttr_t btn1_controller_attributes = {
  .name = "btn1_controller",
  .stack_mem = &btn1_controllerBuffer[0],
  .stack_size = sizeof(btn1_controllerBuffer),
  .cb_mem = &btn1_controllerControlBlock,
  .cb_size = sizeof(btn1_controllerControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for btn2_controller */
osThreadId_t btn2_controllerHandle;
uint32_t btn2_controllerBuffer[ 128 ];
osStaticThreadDef_t btn2_controllerControlBlock;
const osThreadAttr_t btn2_controller_attributes = {
  .name = "btn2_controller",
  .stack_mem = &btn2_controllerBuffer[0],
  .stack_size = sizeof(btn2_controllerBuffer),
  .cb_mem = &btn2_controllerControlBlock,
  .cb_size = sizeof(btn2_controllerControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for led_sts1_drv */
osThreadId_t led_sts1_drvHandle;
uint32_t led_sts1_drvBuffer[ 128 ];
osStaticThreadDef_t led_sts1_drvControlBlock;
const osThreadAttr_t led_sts1_drv_attributes = {
  .name = "led_sts1_drv",
  .stack_mem = &led_sts1_drvBuffer[0],
  .stack_size = sizeof(led_sts1_drvBuffer),
  .cb_mem = &led_sts1_drvControlBlock,
  .cb_size = sizeof(led_sts1_drvControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for led_sts2_drv */
osThreadId_t led_sts2_drvHandle;
uint32_t led_sts2_drvBuffer[ 128 ];
osStaticThreadDef_t led_sts2_drvControlBlock;
const osThreadAttr_t led_sts2_drv_attributes = {
  .name = "led_sts2_drv",
  .stack_mem = &led_sts2_drvBuffer[0],
  .stack_size = sizeof(led_sts2_drvBuffer),
  .cb_mem = &led_sts2_drvControlBlock,
  .cb_size = sizeof(led_sts2_drvControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for ch1_controller */
osThreadId_t ch1_controllerHandle;
uint32_t ch1_controllerBuffer[ 378 ];
osStaticThreadDef_t ch1_controllerControlBlock;
const osThreadAttr_t ch1_controller_attributes = {
  .name = "ch1_controller",
  .stack_mem = &ch1_controllerBuffer[0],
  .stack_size = sizeof(ch1_controllerBuffer),
  .cb_mem = &ch1_controllerControlBlock,
  .cb_size = sizeof(ch1_controllerControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for ch2_controller */
osThreadId_t ch2_controllerHandle;
uint32_t ch2_controllerBuffer[ 378 ];
osStaticThreadDef_t ch2_controllerControlBlock;
const osThreadAttr_t ch2_controller_attributes = {
  .name = "ch2_controller",
  .stack_mem = &ch2_controllerBuffer[0],
  .stack_size = sizeof(ch2_controllerBuffer),
  .cb_mem = &ch2_controllerControlBlock,
  .cb_size = sizeof(ch2_controllerControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for btn3_controller */
osThreadId_t btn3_controllerHandle;
uint32_t btn3_controllerBuffer[ 128 ];
osStaticThreadDef_t btn3_controllerControlBlock;
const osThreadAttr_t btn3_controller_attributes = {
  .name = "btn3_controller",
  .stack_mem = &btn3_controllerBuffer[0],
  .stack_size = sizeof(btn3_controllerBuffer),
  .cb_mem = &btn3_controllerControlBlock,
  .cb_size = sizeof(btn3_controllerControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for btn4_controller */
osThreadId_t btn4_controllerHandle;
uint32_t btn4_controllerBuffer[ 128 ];
osStaticThreadDef_t btn4_controllerControlBlock;
const osThreadAttr_t btn4_controller_attributes = {
  .name = "btn4_controller",
  .stack_mem = &btn4_controllerBuffer[0],
  .stack_size = sizeof(btn4_controllerBuffer),
  .cb_mem = &btn4_controllerControlBlock,
  .cb_size = sizeof(btn4_controllerControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for ui_controller */
osThreadId_t ui_controllerHandle;
uint32_t ui_controllerBuffer[ 10240 ];
osStaticThreadDef_t ui_controllerControlBlock;
const osThreadAttr_t ui_controller_attributes = {
  .name = "ui_controller",
  .stack_mem = &ui_controllerBuffer[0],
  .stack_size = sizeof(ui_controllerBuffer),
  .cb_mem = &ui_controllerControlBlock,
  .cb_size = sizeof(ui_controllerControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for adc_thread */
osThreadId_t adc_threadHandle;
uint32_t adc_threadBuffer[ 378 ];
osStaticThreadDef_t adc_threadControlBlock;
const osThreadAttr_t adc_thread_attributes = {
  .name = "adc_thread",
  .stack_mem = &adc_threadBuffer[0],
  .stack_size = sizeof(adc_threadBuffer),
  .cb_mem = &adc_threadControlBlock,
  .cb_size = sizeof(adc_threadControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for ina219_task */
osThreadId_t ina219_taskHandle;
uint32_t ina219_taskBuffer[ 512 ];
osStaticThreadDef_t ina219_taskControlBlock;
const osThreadAttr_t ina219_task_attributes = {
  .name = "ina219_task",
  .stack_mem = &ina219_taskBuffer[0],
  .stack_size = sizeof(ina219_taskBuffer),
  .cb_mem = &ina219_taskControlBlock,
  .cb_size = sizeof(ina219_taskControlBlock),
  .priority = (osPriority_t) osPriorityLow,
};
/* Definitions for max40080_sample_access */
osMutexId_t max40080_sample_accessHandle;
osStaticMutexDef_t max40080_sample_access_cb;
const osMutexAttr_t max40080_sample_access_attributes = {
  .name = "max40080_sample_access",
  .cb_mem = &max40080_sample_access_cb,
  .cb_size = sizeof(max40080_sample_access_cb),
};
/* Definitions for sts_led1 */
osMutexId_t sts_led1Handle;
osStaticMutexDef_t sts_led1_cb;
const osMutexAttr_t sts_led1_attributes = {
  .name = "sts_led1",
  .cb_mem = &sts_led1_cb,
  .cb_size = sizeof(sts_led1_cb),
};
/* Definitions for sts_led2 */
osMutexId_t sts_led2Handle;
osStaticMutexDef_t sts_led2_cb;
const osMutexAttr_t sts_led2_attributes = {
  .name = "sts_led2",
  .cb_mem = &sts_led2_cb,
  .cb_size = sizeof(sts_led2_cb),
};
/* Definitions for btn1_status */
osMutexId_t btn1_statusHandle;
osStaticMutexDef_t btn1_status_cb;
const osMutexAttr_t btn1_status_attributes = {
  .name = "btn1_status",
  .cb_mem = &btn1_status_cb,
  .cb_size = sizeof(btn1_status_cb),
};
/* Definitions for btn2_status */
osMutexId_t btn2_statusHandle;
osStaticMutexDef_t btn2_status_cb;
const osMutexAttr_t btn2_status_attributes = {
  .name = "btn2_status",
  .cb_mem = &btn2_status_cb,
  .cb_size = sizeof(btn2_status_cb),
};
/* Definitions for btn3_status */
osMutexId_t btn3_statusHandle;
osStaticMutexDef_t btn3_status_cb;
const osMutexAttr_t btn3_status_attributes = {
  .name = "btn3_status",
  .cb_mem = &btn3_status_cb,
  .cb_size = sizeof(btn3_status_cb),
};
/* Definitions for btn4_status */
osMutexId_t btn4_statusHandle;
osStaticMutexDef_t btn4_status_cb;
const osMutexAttr_t btn4_status_attributes = {
  .name = "btn4_status",
  .cb_mem = &btn4_status_cb,
  .cb_size = sizeof(btn4_status_cb),
};
/* Definitions for ch1_ctl_status */
osMutexId_t ch1_ctl_statusHandle;
osStaticMutexDef_t ch1_ctl_statusControlBlock;
const osMutexAttr_t ch1_ctl_status_attributes = {
  .name = "ch1_ctl_status",
  .cb_mem = &ch1_ctl_statusControlBlock,
  .cb_size = sizeof(ch1_ctl_statusControlBlock),
};
/* Definitions for ch2_ctl_status */
osMutexId_t ch2_ctl_statusHandle;
osStaticMutexDef_t ch2_ctl_statusControlBlock;
const osMutexAttr_t ch2_ctl_status_attributes = {
  .name = "ch2_ctl_status",
  .cb_mem = &ch2_ctl_statusControlBlock,
  .cb_size = sizeof(ch2_ctl_statusControlBlock),
};
/* Definitions for adc_status */
osMutexId_t adc_statusHandle;
osStaticMutexDef_t adc_statusControlBlock;
const osMutexAttr_t adc_status_attributes = {
  .name = "adc_status",
  .cb_mem = &adc_statusControlBlock,
  .cb_size = sizeof(adc_statusControlBlock),
};
/* Definitions for ina219_sample_access */
osMutexId_t ina219_sample_accessHandle;
osStaticMutexDef_t ina219_sample_accessControlBlock;
const osMutexAttr_t ina219_sample_access_attributes = {
  .name = "ina219_sample_access",
  .cb_mem = &ina219_sample_accessControlBlock,
  .cb_size = sizeof(ina219_sample_accessControlBlock),
};
/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_USB_PCD_Init(void);
static void MX_ICACHE_Init(void);
static void MX_TIM7_Init(void);
static void MX_ADC1_Init(void);
static void MX_I2C1_Init(void);
static void MX_LPUART1_UART_Init(void);
static void MX_I2C4_Init(void);
static void MX_SPI1_Init(void);
void StartDefaultTask(void *argument);
void max40080_task_entry(void *argument);
void btn1_controller_entry(void *argument);
void btn2_controller_entry(void *argument);
void led_sts1_drv_entry(void *argument);
void led_sts2_drv_entry(void *argument);
void ch1_controller_entry(void *argument);
void ch2_controller_entry(void *argument);
void btn3_controller_entry(void *argument);
void btn4_controller_entry(void *argument);
void ui_controller_entry(void *argument);
void adc_thread_entry(void *argument);
void ina219_task_entry(void *argument);

/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */


	SevenSegment_Init();

	SevenSegment_SetDigit(0, DISPA_SEG_A | DISPA_SEG_B | DISPA_SEG_C | DISPA_SEG_E | DISPA_SEG_F | DISPA_SEG_G);
	SevenSegment_SetDigit(5, DISPA_SEG_B | DISPA_SEG_C | DISPA_SEG_E | DISPA_SEG_F | DISPA_SEG_G);
	SevenSegment_SetDigit(2, DISPA_SEG_A | DISPA_SEG_B | DISPA_SEG_C | DISPA_SEG_E | DISPA_SEG_F | DISPA_SEG_D);
	SevenSegment_SetDigit(6, DISPA_SEG_A | DISPA_SEG_B | DISPA_SEG_C | DISPA_SEG_E | DISPA_SEG_F | DISPA_SEG_D);
	SevenSegment_SetDigit(3, DISPA_SEG_B | DISPA_SEG_C | DISPA_SEG_E | DISPA_SEG_D);
	SevenSegment_SetDigit(7, DISPA_SEG_B | DISPA_SEG_C | DISPA_SEG_E | DISPA_SEG_D);

	SevenSegment_SetDigit(8, DISPB_SEG_H | DISPB_SEG_G );
	SevenSegment_SetDigit(9, DISPB_SEG_T | DISPB_SEG_N);

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USB_PCD_Init();
  MX_ICACHE_Init();
  MX_TIM7_Init();
  MX_ADC1_Init();
  MX_I2C1_Init();
  MX_LPUART1_UART_Init();
  MX_I2C4_Init();
  MX_SPI1_Init();
  /* USER CODE BEGIN 2 */

  UART_Init();
  UART_PrintString("UART Intialization completed.\r\n");
	HAL_TIM_Base_Start_IT(&htim7);
	MAX5715_Init();
	MAX5715_SetReference(1, MAX5715_Reference_4V096);
	MAX5715_SetDAC(MAX5715_Channel_A, 1200);

  /* USER CODE END 2 */

  /* Init scheduler */
  osKernelInitialize();
  /* Create the mutex(es) */
  /* creation of max40080_sample_access */
  max40080_sample_accessHandle = osMutexNew(&max40080_sample_access_attributes);

  /* creation of sts_led1 */
  sts_led1Handle = osMutexNew(&sts_led1_attributes);

  /* creation of sts_led2 */
  sts_led2Handle = osMutexNew(&sts_led2_attributes);

  /* creation of btn1_status */
  btn1_statusHandle = osMutexNew(&btn1_status_attributes);

  /* creation of btn2_status */
  btn2_statusHandle = osMutexNew(&btn2_status_attributes);

  /* creation of btn3_status */
  btn3_statusHandle = osMutexNew(&btn3_status_attributes);

  /* creation of btn4_status */
  btn4_statusHandle = osMutexNew(&btn4_status_attributes);

  /* creation of ch1_ctl_status */
  ch1_ctl_statusHandle = osMutexNew(&ch1_ctl_status_attributes);

  /* creation of ch2_ctl_status */
  ch2_ctl_statusHandle = osMutexNew(&ch2_ctl_status_attributes);

  /* creation of adc_status */
  adc_statusHandle = osMutexNew(&adc_status_attributes);

  /* creation of ina219_sample_access */
  ina219_sample_accessHandle = osMutexNew(&ina219_sample_access_attributes);

  /* USER CODE BEGIN RTOS_MUTEX */
	/* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
	/* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
	/* start timers, add new ones, ... */
  /* USER CODE END RTOS_TIMERS */

  /* USER CODE BEGIN RTOS_QUEUES */
	/* add queues, ... */
  /* USER CODE END RTOS_QUEUES */

  /* Create the thread(s) */
  /* creation of defaultTask */
  defaultTaskHandle = osThreadNew(StartDefaultTask, NULL, &defaultTask_attributes);

  /* creation of max40080_task */
  max40080_taskHandle = osThreadNew(max40080_task_entry, NULL, &max40080_task_attributes);

  /* creation of btn1_controller */
  btn1_controllerHandle = osThreadNew(btn1_controller_entry, NULL, &btn1_controller_attributes);

  /* creation of btn2_controller */
  btn2_controllerHandle = osThreadNew(btn2_controller_entry, NULL, &btn2_controller_attributes);

  /* creation of led_sts1_drv */
  led_sts1_drvHandle = osThreadNew(led_sts1_drv_entry, NULL, &led_sts1_drv_attributes);

  /* creation of led_sts2_drv */
  led_sts2_drvHandle = osThreadNew(led_sts2_drv_entry, NULL, &led_sts2_drv_attributes);

  /* creation of ch1_controller */
  ch1_controllerHandle = osThreadNew(ch1_controller_entry, NULL, &ch1_controller_attributes);

  /* creation of ch2_controller */
  ch2_controllerHandle = osThreadNew(ch2_controller_entry, NULL, &ch2_controller_attributes);

  /* creation of btn3_controller */
  btn3_controllerHandle = osThreadNew(btn3_controller_entry, NULL, &btn3_controller_attributes);

  /* creation of btn4_controller */
  btn4_controllerHandle = osThreadNew(btn4_controller_entry, NULL, &btn4_controller_attributes);

  /* creation of ui_controller */
  ui_controllerHandle = osThreadNew(ui_controller_entry, NULL, &ui_controller_attributes);

  /* creation of adc_thread */
  adc_threadHandle = osThreadNew(adc_thread_entry, NULL, &adc_thread_attributes);

  /* creation of ina219_task */
  ina219_taskHandle = osThreadNew(ina219_task_entry, NULL, &ina219_task_attributes);

  /* USER CODE BEGIN RTOS_THREADS */
	/* add threads, ... */
  /* USER CODE END RTOS_THREADS */

  /* USER CODE BEGIN RTOS_EVENTS */
	/* add events, ... */
  /* USER CODE END RTOS_EVENTS */

  /* Start scheduler */
  osKernelStart();

  /* We should never get here as control is now taken by the scheduler */
  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
	while (1) {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
	}
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  if (HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE0) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI48|RCC_OSCILLATORTYPE_MSI;
  RCC_OscInitStruct.HSI48State = RCC_HSI48_ON;
  RCC_OscInitStruct.MSIState = RCC_MSI_ON;
  RCC_OscInitStruct.MSICalibrationValue = RCC_MSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.MSIClockRange = RCC_MSIRANGE_6;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_MSI;
  RCC_OscInitStruct.PLL.PLLM = 1;
  RCC_OscInitStruct.PLL.PLLN = 55;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV7;
  RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
  RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief ADC1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_ADC1_Init(void)
{

  /* USER CODE BEGIN ADC1_Init 0 */

  /* USER CODE END ADC1_Init 0 */

  ADC_MultiModeTypeDef multimode = {0};
  ADC_ChannelConfTypeDef sConfig = {0};

  /* USER CODE BEGIN ADC1_Init 1 */

  /* USER CODE END ADC1_Init 1 */

  /** Common config
  */
  hadc1.Instance = ADC1;
  hadc1.Init.ClockPrescaler = ADC_CLOCK_ASYNC_DIV4;
  hadc1.Init.Resolution = ADC_RESOLUTION_12B;
  hadc1.Init.DataAlign = ADC_DATAALIGN_RIGHT;
  hadc1.Init.ScanConvMode = ADC_SCAN_DISABLE;
  hadc1.Init.EOCSelection = ADC_EOC_SINGLE_CONV;
  hadc1.Init.LowPowerAutoWait = DISABLE;
  hadc1.Init.ContinuousConvMode = DISABLE;
  hadc1.Init.NbrOfConversion = 1;
  hadc1.Init.DiscontinuousConvMode = DISABLE;
  hadc1.Init.ExternalTrigConv = ADC_SOFTWARE_START;
  hadc1.Init.ExternalTrigConvEdge = ADC_EXTERNALTRIGCONVEDGE_NONE;
  hadc1.Init.DMAContinuousRequests = DISABLE;
  hadc1.Init.Overrun = ADC_OVR_DATA_PRESERVED;
  hadc1.Init.OversamplingMode = DISABLE;
  if (HAL_ADC_Init(&hadc1) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure the ADC multi-mode
  */
  multimode.Mode = ADC_MODE_INDEPENDENT;
  if (HAL_ADCEx_MultiModeConfigChannel(&hadc1, &multimode) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure Regular Channel
  */
  sConfig.Channel = ADC_CHANNEL_8;
  sConfig.Rank = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_2CYCLES_5;
  sConfig.SingleDiff = ADC_SINGLE_ENDED;
  sConfig.OffsetNumber = ADC_OFFSET_NONE;
  sConfig.Offset = 0;
  if (HAL_ADC_ConfigChannel(&hadc1, &sConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN ADC1_Init 2 */

  /* USER CODE END ADC1_Init 2 */

}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.Timing = 0x40505681;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.OwnAddress2Masks = I2C_OA2_NOMASK;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure Analogue filter
  */
  if (HAL_I2CEx_ConfigAnalogFilter(&hi2c1, I2C_ANALOGFILTER_ENABLE) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure Digital filter
  */
  if (HAL_I2CEx_ConfigDigitalFilter(&hi2c1, 0) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief I2C4 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C4_Init(void)
{

  /* USER CODE BEGIN I2C4_Init 0 */

  /* USER CODE END I2C4_Init 0 */

  /* USER CODE BEGIN I2C4_Init 1 */

  /* USER CODE END I2C4_Init 1 */
  hi2c4.Instance = I2C4;
  hi2c4.Init.Timing = 0x40505681;
  hi2c4.Init.OwnAddress1 = 0;
  hi2c4.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c4.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c4.Init.OwnAddress2 = 0;
  hi2c4.Init.OwnAddress2Masks = I2C_OA2_NOMASK;
  hi2c4.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c4.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c4) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure Analogue filter
  */
  if (HAL_I2CEx_ConfigAnalogFilter(&hi2c4, I2C_ANALOGFILTER_ENABLE) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure Digital filter
  */
  if (HAL_I2CEx_ConfigDigitalFilter(&hi2c4, 0) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C4_Init 2 */

  /* USER CODE END I2C4_Init 2 */

}

/**
  * @brief ICACHE Initialization Function
  * @param None
  * @retval None
  */
static void MX_ICACHE_Init(void)
{

  /* USER CODE BEGIN ICACHE_Init 0 */

  /* USER CODE END ICACHE_Init 0 */

  /* USER CODE BEGIN ICACHE_Init 1 */

  /* USER CODE END ICACHE_Init 1 */

  /** Enable instruction cache in 1-way (direct mapped cache)
  */
  if (HAL_ICACHE_ConfigAssociativityMode(ICACHE_1WAY) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_ICACHE_Enable() != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN ICACHE_Init 2 */

  /* USER CODE END ICACHE_Init 2 */

}

/**
  * @brief LPUART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_LPUART1_UART_Init(void)
{

  /* USER CODE BEGIN LPUART1_Init 0 */

  /* USER CODE END LPUART1_Init 0 */

  /* USER CODE BEGIN LPUART1_Init 1 */

  /* USER CODE END LPUART1_Init 1 */
  hlpuart1.Instance = LPUART1;
  hlpuart1.Init.BaudRate = 115200;
  hlpuart1.Init.WordLength = UART_WORDLENGTH_8B;
  hlpuart1.Init.StopBits = UART_STOPBITS_1;
  hlpuart1.Init.Parity = UART_PARITY_NONE;
  hlpuart1.Init.Mode = UART_MODE_TX_RX;
  hlpuart1.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  hlpuart1.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  hlpuart1.Init.ClockPrescaler = UART_PRESCALER_DIV1;
  hlpuart1.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  hlpuart1.FifoMode = UART_FIFOMODE_DISABLE;
  if (HAL_UART_Init(&hlpuart1) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_SetTxFifoThreshold(&hlpuart1, UART_TXFIFO_THRESHOLD_1_8) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_SetRxFifoThreshold(&hlpuart1, UART_RXFIFO_THRESHOLD_1_8) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_DisableFifoMode(&hlpuart1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN LPUART1_Init 2 */

  /* USER CODE END LPUART1_Init 2 */

}

/**
  * @brief SPI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI1_Init(void)
{

  /* USER CODE BEGIN SPI1_Init 0 */

  /* USER CODE END SPI1_Init 0 */

  /* USER CODE BEGIN SPI1_Init 1 */

  /* USER CODE END SPI1_Init 1 */
  /* SPI1 parameter configuration*/
  hspi1.Instance = SPI1;
  hspi1.Init.Mode = SPI_MODE_MASTER;
  hspi1.Init.Direction = SPI_DIRECTION_2LINES;
  hspi1.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi1.Init.CLKPhase = SPI_PHASE_2EDGE;
  hspi1.Init.NSS = SPI_NSS_SOFT;
  hspi1.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_64;
  hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi1.Init.CRCPolynomial = 7;
  hspi1.Init.CRCLength = SPI_CRC_LENGTH_DATASIZE;
  hspi1.Init.NSSPMode = SPI_NSS_PULSE_DISABLE;
  if (HAL_SPI_Init(&hspi1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI1_Init 2 */

  /* USER CODE END SPI1_Init 2 */

}

/**
  * @brief TIM7 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM7_Init(void)
{

  /* USER CODE BEGIN TIM7_Init 0 */

  /* USER CODE END TIM7_Init 0 */

  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM7_Init 1 */

  /* USER CODE END TIM7_Init 1 */
  htim7.Instance = TIM7;
  htim7.Init.Prescaler = 220;
  htim7.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim7.Init.Period = 500;
  htim7.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  if (HAL_TIM_Base_Init(&htim7) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim7, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM7_Init 2 */

  /* USER CODE END TIM7_Init 2 */

}

/**
  * @brief USB Initialization Function
  * @param None
  * @retval None
  */
static void MX_USB_PCD_Init(void)
{

  /* USER CODE BEGIN USB_Init 0 */

  /* USER CODE END USB_Init 0 */

  /* USER CODE BEGIN USB_Init 1 */

  /* USER CODE END USB_Init 1 */
  hpcd_USB_FS.Instance = USB;
  hpcd_USB_FS.Init.dev_endpoints = 8;
  hpcd_USB_FS.Init.speed = PCD_SPEED_FULL;
  hpcd_USB_FS.Init.phy_itface = PCD_PHY_EMBEDDED;
  hpcd_USB_FS.Init.Sof_enable = DISABLE;
  hpcd_USB_FS.Init.low_power_enable = DISABLE;
  hpcd_USB_FS.Init.lpm_enable = DISABLE;
  hpcd_USB_FS.Init.battery_charging_enable = DISABLE;
  if (HAL_PCD_Init(&hpcd_USB_FS) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USB_Init 2 */

  /* USER CODE END USB_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOE_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOF_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOG_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();
  HAL_PWREx_EnableVddIO2();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOE, GPIO_PIN_2|GPIO_PIN_3|GPIO_PIN_6, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOF, GPIO_PIN_0|GPIO_PIN_1, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_3|GPIO_PIN_6
                          |LED_GREEN_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, GPIO_PIN_4|LED_RED_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_4
                          |UCPD_DBN_Pin|GPIO_PIN_6|LED_BLUE_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOF, GPIO_PIN_13, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOG, GPIO_PIN_0|GPIO_PIN_1, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOE, GPIO_PIN_9, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOD, GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_11|GPIO_PIN_12
                          |GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3
                          |GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7, GPIO_PIN_RESET);

  /*Configure GPIO pins : PE2 PE3 PE6 PE9 */
  GPIO_InitStruct.Pin = GPIO_PIN_2|GPIO_PIN_3|GPIO_PIN_6|GPIO_PIN_9;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOE, &GPIO_InitStruct);

  /*Configure GPIO pins : PF0 PF1 PF13 */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_13;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOF, &GPIO_InitStruct);

  /*Configure GPIO pins : PC0 PC1 PC3 PC6
                           LED_GREEN_Pin */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_3|GPIO_PIN_6
                          |LED_GREEN_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : PA4 LED_RED_Pin */
  GPIO_InitStruct.Pin = GPIO_PIN_4|LED_RED_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : PB0 PB1 PB2 PB4
                           UCPD_DBN_Pin PB6 LED_BLUE_Pin */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_4
                          |UCPD_DBN_Pin|GPIO_PIN_6|LED_BLUE_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pins : PG0 PG1 */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOG, &GPIO_InitStruct);

  /*Configure GPIO pins : PE14 PE15 */
  GPIO_InitStruct.Pin = GPIO_PIN_14|GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOE, &GPIO_InitStruct);

  /*Configure GPIO pins : PB10 PB11 */
  GPIO_InitStruct.Pin = GPIO_PIN_10|GPIO_PIN_11;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : UCPD_FLT_Pin */
  GPIO_InitStruct.Pin = UCPD_FLT_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(UCPD_FLT_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : PB15 */
  GPIO_InitStruct.Pin = GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pins : PD8 PD9 PD11 PD12
                           PD0 PD1 PD2 PD3
                           PD4 PD5 PD6 PD7 */
  GPIO_InitStruct.Pin = GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_11|GPIO_PIN_12
                          |GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3
                          |GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOD, &GPIO_InitStruct);

  /*Configure GPIO pin : PA15 */
  GPIO_InitStruct.Pin = GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/* USER CODE BEGIN Header_StartDefaultTask */
/**
 * @brief  Function implementing the defaultTask thread.
 * @param  argument: Not used
 * @retval None
 */
/* USER CODE END Header_StartDefaultTask */
void StartDefaultTask(void *argument)
{
  /* USER CODE BEGIN 5 */
	/* Infinite loop */

	StatusLed_SetState(0, 0, 1);
	StatusLed_SetState(1, 0, 0);

	for (;;) {
		osDelay(1);
	}
  /* USER CODE END 5 */
}

/* USER CODE BEGIN Header_max40080_task_entry */
/**
 * @brief Function implementing the max40080_task thread.
 * @param argument: Not used
 * @retval None
 */
/* USER CODE END Header_max40080_task_entry */
void max40080_task_entry(void *argument)
{
  /* USER CODE BEGIN max40080_task_entry */
	MAX40080Driver_ThreadEntry();
  /* USER CODE END max40080_task_entry */
}

/* USER CODE BEGIN Header_btn1_controller_entry */
/**
* @brief Function implementing the btn1_controller thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_btn1_controller_entry */
void btn1_controller_entry(void *argument)
{
  /* USER CODE BEGIN btn1_controller_entry */
	ButtonDriver_ThreadEntry(0, GPIOE, GPIO_PIN_14);
  /* USER CODE END btn1_controller_entry */
}

/* USER CODE BEGIN Header_btn2_controller_entry */
/**
* @brief Function implementing the btn2_controller thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_btn2_controller_entry */
void btn2_controller_entry(void *argument)
{
  /* USER CODE BEGIN btn2_controller_entry */
	ButtonDriver_ThreadEntry(1, GPIOE, GPIO_PIN_15);
  /* USER CODE END btn2_controller_entry */
}

/* USER CODE BEGIN Header_led_sts1_drv_entry */
/**
* @brief Function implementing the led_sts1_drv thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_led_sts1_drv_entry */
void led_sts1_drv_entry(void *argument)
{
  /* USER CODE BEGIN led_sts1_drv_entry */
	StatusLed_DriverThread(0, GPIOE, GPIO_PIN_6, GPIOE, GPIO_PIN_3);
  /* USER CODE END led_sts1_drv_entry */
}

/* USER CODE BEGIN Header_led_sts2_drv_entry */
/**
* @brief Function implementing the led_sts2_drv thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_led_sts2_drv_entry */
void led_sts2_drv_entry(void *argument)
{
  /* USER CODE BEGIN led_sts2_drv_entry */
  StatusLed_DriverThread(1, GPIOF, GPIO_PIN_1, GPIOF, GPIO_PIN_0);
  /* USER CODE END led_sts2_drv_entry */
}

/* USER CODE BEGIN Header_ch1_controller_entry */
/**
* @brief Function implementing the ch1_controller thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_ch1_controller_entry */
void ch1_controller_entry(void *argument)
{
  /* USER CODE BEGIN ch1_controller_entry */
	ChannelController_ThreadEntry(0);
  /* USER CODE END ch1_controller_entry */
}

/* USER CODE BEGIN Header_ch2_controller_entry */
/**
* @brief Function implementing the ch2_controller thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_ch2_controller_entry */
void ch2_controller_entry(void *argument)
{
  /* USER CODE BEGIN ch2_controller_entry */
	ChannelController_ThreadEntry(1);
  /* USER CODE END ch2_controller_entry */
}

/* USER CODE BEGIN Header_btn3_controller_entry */
/**
* @brief Function implementing the btn3_controller thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_btn3_controller_entry */
void btn3_controller_entry(void *argument)
{
  /* USER CODE BEGIN btn3_controller_entry */
	ButtonDriver_ThreadEntry(2, GPIOB, GPIO_PIN_10);
  /* USER CODE END btn3_controller_entry */
}

/* USER CODE BEGIN Header_btn4_controller_entry */
/**
* @brief Function implementing the btn4_controller thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_btn4_controller_entry */
void btn4_controller_entry(void *argument)
{
  /* USER CODE BEGIN btn4_controller_entry */
	ButtonDriver_ThreadEntry(3, GPIOB, GPIO_PIN_11);
  /* USER CODE END btn4_controller_entry */
}

/* USER CODE BEGIN Header_ui_controller_entry */
/**
* @brief Function implementing the ui_controller thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_ui_controller_entry */
void ui_controller_entry(void *argument)
{
  /* USER CODE BEGIN ui_controller_entry */
	UiController_ThreadEntry();
  /* USER CODE END ui_controller_entry */
}

/* USER CODE BEGIN Header_adc_thread_entry */
/**
* @brief Function implementing the adc_thread thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_adc_thread_entry */
void adc_thread_entry(void *argument)
{
  /* USER CODE BEGIN adc_thread_entry */
	AdcDriver_ThreadEntry();
  /* USER CODE END adc_thread_entry */
}

/* USER CODE BEGIN Header_ina219_task_entry */
/**
* @brief Function implementing the ina219_task thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_ina219_task_entry */
void ina219_task_entry(void *argument)
{
  /* USER CODE BEGIN ina219_task_entry */
	INA219Driver_ThreadEntry();
  /* USER CODE END ina219_task_entry */
}

/**
  * @brief  Period elapsed callback in non blocking mode
  * @note   This function is called  when TIM6 interrupt took place, inside
  * HAL_TIM_IRQHandler(). It makes a direct call to HAL_IncTick() to increment
  * a global variable "uwTick" used as application time base.
  * @param  htim : TIM handle
  * @retval None
  */
void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
  /* USER CODE BEGIN Callback 0 */

  /* USER CODE END Callback 0 */
  if (htim->Instance == TIM6) {
    HAL_IncTick();
  }
  /* USER CODE BEGIN Callback 1 */

  /* USER CODE END Callback 1 */
}

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */
	__disable_irq();
	while (1) {
	}
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
